#pragma once

#include "../GeneratedFiles/ui_TransferWindow.h"
#include "RENDER\global.h"

#include <QtWidgets\qdialog.h>
#include <QtWidgets\qwidget.h>
#include <QtWidgets\qcolordialog.h>
#include <QtGui\qcolor.h>

/** A subclass representing an input dialog to edit the values or create a new a transfer function */
class TransferWindow : public QDialog
{

	Q_OBJECT;

public:
	TransferWindow(QWidget *parent = 0, int editIndex = -1);
	~TransferWindow();

private:
	Ui_Transfer* ui;

	/** the initial min value */
	int baseFirstValue;

	/** the initial max value */
	int baseSecondValue;

	/** the initial opacity value */
	float baseOptValue;

	/** the initial color value */
	float baseColorValue[3];

	/** the index of the transfer function being edited */
	int index;

	

	/** flag that indicates if a transfer function is being edited or created */
	bool newFunction;

	private slots:

	/** calls a color dialog to assign a new color */
	void getColor();

	/** reads the slider values and assigns them to the transfer function at a given index */
	void setTransferFunction();
	
	/** if the cancel button is hit, the initial values of the transfer function are restored or the new transfer function is deleted */
	void rejectChanges();
};

