#pragma once

#include "../GeneratedFiles/ui_ViewWindow.h"

#include <QtWidgets\qwidget.h>
#include <QtWidgets\qdialog.h>
#include <QtWidgets\qdialogbuttonbox.h>
#include <QtWidgets\qslider.h>

/** A subclass representing an input dialog to edit the position of the focus plane and the blurring effect */
class ViewWindow : public QDialog {

	Q_OBJECT

public:
	ViewWindow(QWidget *parent = 0);
	~ViewWindow();

private:
	Ui_Dialog * ui;
	
	/** the initial plane in focus */
	int baseFocusValue;

	/** the initial blurring value as percentage*/
	int baseBlurValue;

	/** transform a relativ value to absolute in the range of 0 to 100 
	* @value the relative blurring value
	* @max the maximal blurring value
	* @return the absolute value of the blurring effect for labeling purposes
	*/
	int toPercentage(const float& value, const float& max);

	private slots:

	/** gets the actual value of the focus slider */
	void getFocusSliderValue();

	/** gets the actual value of the blur slider */
	void getBlurSliderValue();

	/** if the cancel button is clicked, the initial focus and blurring values are restored */
	void rejectValue();
};

