#include "FBO.h"

FBO::FBO()
{
    float borderColor[] = { 0.0f, 0.0f, 0.0f, 0.0f };
	glGenFramebuffers(1, &id);
	glGenTextures(1, &txo);

	glBindFramebuffer(GL_FRAMEBUFFER, id);
	glBindTexture(GL_TEXTURE_2D, txo);

	glTexStorage2D(GL_TEXTURE_2D, 1, GL_RGBA8, 1024, 1024);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);

    glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_BORDER_COLOR, borderColor);

	glFramebufferTexture(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, txo, 0);

	if (glCheckFramebufferStatus(GL_FRAMEBUFFER) != GL_FRAMEBUFFER_COMPLETE)
		std::cerr << "Framebuffer initialization error: " << glCheckFramebufferStatus(GL_FRAMEBUFFER) << std::endl;

	glDrawBuffer(GL_COLOR_ATTACHMENT0);

	glBindFramebuffer(GL_FRAMEBUFFER, 0);
	glBindTexture(GL_TEXTURE_2D, 0);
}


FBO::~FBO()
{
	glDeleteFramebuffers(1, &id);
	glDeleteTextures(1, &txo);
}

const GLuint FBO::getID() const {
	return id;
}

const GLuint FBO::getTXO() const {
	return txo;
}
