#include "GLCamera.h"

GLCamera::GLCamera(const QVector3D& _pos, const QVector3D& _target)
{
	position = _pos;
	target = _target;
	//viewMatrix.lookAt(_pos, _target - _pos, QVector3D(0, 1, 0));
	viewMatrix.lookAt(position, position + target, UP);
}


GLCamera::~GLCamera()
{
}

void GLCamera::setProjection(const int & width, const int & height)
{
	projMatrix.setToIdentity();
	projMatrix.perspective(45.f, (float)width / (float)height, .01f, 100.f);
}

void GLCamera::zoom(const int& faktor)
{

	position.setZ(-faktor);

	viewMatrix.lookAt(position, position + target, UP);

}

void GLCamera::setMMatrix(const QMatrix4x4& modelMatrix) {
	this->modelMatrix = modelMatrix;
}

const QMatrix4x4 GLCamera::getPVMMatrix() const {
	return projMatrix * viewMatrix * modelMatrix;
}

const QMatrix4x4 GLCamera::getVMatrix() const {
	return viewMatrix;
}

const QMatrix4x4 GLCamera::getProjection() const {
	return projMatrix;
}

const QMatrix4x4 GLCamera::getModelMatrix() const {
	return modelMatrix;
}