#include "GLShader.h"

#include <iostream>
#include <stdexcept>


//#include <QtCore\qfileinfo.h>

GLShader::GLShader(const QString& _vertex, const QString& _fragment)
{
    createShader(_vertex, _fragment);
}


GLShader::~GLShader()
{
	if (renderable) {
		delete linker;
		linker = nullptr;
	}
	
}

void GLShader::prepare(const GLuint& vao) {

    glUseProgram(program);
	glBindVertexArray(vao);
    glEnableVertexAttribArray(0);
    glEnableVertexAttribArray(1);
	

}

void GLShader::cleanUp() {

    glDisableVertexAttribArray(0);
    glDisableVertexAttribArray(1);
    glUseProgram(0);
    glBindVertexArray(0);
}

const bool GLShader::isRenderable() const
{
	return renderable;
}

void GLShader::createShader(const QString& _vertex, const QString& _fragment)
{
	linker = new QOpenGLShaderProgram();
	linker->addShaderFromSourceFile(QOpenGLShader::Vertex, _vertex);
	linker->addShaderFromSourceFile(QOpenGLShader::Fragment, _fragment);
	bool link = linker->link();

	if (link == false) {
		std::cout << linker->log().toStdString().c_str() << std::endl;
		//throw std::exception(linker->log().toStdString().c_str());
		renderable = false;
		delete linker;
	}
	else
		program = linker->programId();

}