#pragma once

#include <vector>
#include "GUI\Volume.h"
#include "TransferFunction.h"

/** this file is used for gui-logic interactions */

/** the volume to be rendered */
extern Volume* volume;

/** boolean flag to reset the renderer */
extern bool newVolume;

/** actual plane in focus */
extern int focusPlane;

/** the last plane in the volume */
extern int lastFocusPlane;

/** stores the absolute blurring value in degrees */
extern float blurAccum;

/** stores the relativ blurring value tan(blur/2) */
extern float blurAttenuation;

/** stores the maximal absolute blurring value to avoid negativ values */
extern const float maxBlurAttenuation;

/** number of actual transfer functions */
extern int  tfsSize;

/** array containing up to 5 transfer function objects */
extern TransferFunction* tfs[5];