#include "QuadShader.h"



QuadShader::QuadShader():
GLShader("SHADER/QuadShaderVertex", "SHADER/QuadShaderFragment")
{
	//QFileInfo info(":/Vertex");
	//std::cout << info.absoluteFilePath().toStdString() << std::endl;

	configShader();
}


QuadShader::~QuadShader()
{
}

void QuadShader::draw(const GLuint& text, GLCamera& camera)
{
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, text);
	glUniform1i(textLocation, 0);
    glUniformMatrix4fv(projectionMatrixLocation, 1, GL_FALSE, camera.getProjection().data());
    glUniformMatrix4fv(viewMatrixLocation, 1, GL_FALSE, camera.getVMatrix().data());
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glActiveTexture(GL_TEXTURE0);

	glBindTexture(GL_TEXTURE_2D, 0);

}

void QuadShader::configShader()
{
	textLocation = glGetUniformLocation(program, "text");
    projectionMatrixLocation = glGetUniformLocation(program, "projMatrix");
    viewMatrixLocation = glGetUniformLocation(program, "viewMatrix");
}
