#pragma once

#include "glew.h"
#include <string>
#include <QtGui\qopenglshaderprogram.h>

#include "RENDER\GLShader.h"

/** A class for rendering a textured quad */
class QuadShader: public GLShader
{
public:
	QuadShader();
	~QuadShader();

    /** draws a quad 
     * @param text: texture id
     * @param camera: camera with necessary matrices
     */
	void draw(const GLuint& text, GLCamera& camera);

private:
	
	/** prepares the uniform locations */
	void configShader();

    /** uniform location of texture */
	GLint textLocation;
    /** uniform location of projection matrix */
    GLint projectionMatrixLocation;
    /** uniform location of view matrix */
    GLint viewMatrixLocation;
};

