#include "Tex3DShader.h"

#include <QtCore\qmath.h>

Tex3DShader::Tex3DShader() : GLShader("SHADER/Tex3DVertex", "SHADER/Tex3DFragment")
{
    if (renderable)
        configShader();
}

Tex3DShader::~Tex3DShader()
{
}

void Tex3DShader::prepare(GLCamera& camera, const GLuint& quadVAO, const GLuint& volTEX)
{
    GLShader::prepare(quadVAO);

    glActiveTexture(GL_TEXTURE0);
    glBindTexture(GL_TEXTURE_3D, volTEX);
    glUniform1i(volumeTextureLocation, 0);
}

void Tex3DShader::configShader()
{
    volumeTextureLocation = glGetUniformLocation(program, "volumeTexture");
}

void Tex3DShader::draw(FBO* fbo) {
    glBindFramebuffer(GL_FRAMEBUFFER, fbo->getID());
    glDisable(GL_BLEND);

    glDrawArrays(GL_TRIANGLE_FAN, 0, 4);
    glBindFramebuffer(GL_FRAMEBUFFER, 0);
}