#pragma once

#include <iostream>

#include "RENDER\GLShader.h"
#include "RENDER\FBO.h"

/** A class for rendering a slice from a 3D texture */
class Tex3DShader : public GLShader
{
    public:
    Tex3DShader();
    ~Tex3DShader();

    /** renders a texture slice from a 3D texture
     * @param fbo: the fbo we are rendering in
     */
    void draw(FBO* fbo);

    /** activates the program and loads the uniform datas
     * @param camera: camera with matrices
     * @param quadVAO: vao containing quad vertices
     * @param volTex: 3d texture ID
     */
    void prepare(GLCamera& camera, const GLuint& quadVAO, const GLuint& volTEX);

    private:
    /** get uniform locations */
    void configShader() override;

    GLint volumeTextureLocation;
};